package my.rcp.gefeditor.commands;

import my.rcp.gefeditor.mvc.model.MyBlock;

import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.commands.Command;

/** Command that changes Constraints for a block */
public class BlockChangeConstraintCommand extends Command {

	// actual and old constraint
	private Rectangle newConstraint;
	private Rectangle oldConstraint;
	// object of the command
	private MyBlock block;
	
	/** Public method that executes the command. */
	public void execute(){
		// save previous value
		if( oldConstraint == null )
			oldConstraint = new Rectangle(block.getConstraint());
		// set actual value
		block.setConstraint(newConstraint);
	}
	
	/** Undo method that reset to old value */
	public void undo(){
		block.setConstraint(oldConstraint);
	}
	
	/** Set new constraint for block. */
	public void setNewConstraint(Rectangle newConstraint){
		this.newConstraint = newConstraint;
	}
	
	/** Set the Block obejct of the command. */
	public void setBlock(MyBlock block){
		this.block = block;
	}
	
}
