package my.rcp.gefeditor.editors;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.gef.DefaultEditDomain;
import org.eclipse.gef.GraphicalViewer;
import org.eclipse.gef.editparts.ScalableFreeformRootEditPart;
import org.eclipse.gef.palette.PaletteRoot;
import org.eclipse.gef.ui.actions.RedoAction;
import org.eclipse.gef.ui.actions.UndoAction;
import org.eclipse.gef.ui.parts.GraphicalEditorWithFlyoutPalette;

/** This class implements the concrete editor */
public class MyEditor extends GraphicalEditorWithFlyoutPalette {

	/** this is the public ID for the editor */
	public static final String ID = "my.rcp.gefeditor.editors.MyEditor";
	
	public MyEditor() { 
		// the edit domain is necessary
		setEditDomain( new DefaultEditDomain(this) );
	}
	
	@Override
	protected PaletteRoot getPaletteRoot() {
		return new PaletteRoot();
	}

	@Override
	public void doSave(IProgressMonitor monitor) { }
	
	@Override
	protected void configureGraphicalViewer() {
		super.configureGraphicalViewer();
		super.configureGraphicalViewer();
		// viewer <-- factory + root edit part
		GraphicalViewer viewer = getGraphicalViewer();
		viewer.setEditPartFactory( new MyEditPartFactory() );
		viewer.setRootEditPart( new ScalableFreeformRootEditPart() );
	}
	
	@Override
	protected void initializeGraphicalViewer() {
		super.initializeGraphicalViewer();
		// set the root model to be rendered 
		getGraphicalViewer().setContents(
			MyContentProvider.INSTANCE.sample()
		);
		getActionRegistry().registerAction(new UndoAction(this));
		getActionRegistry().registerAction(new RedoAction(this));
	}

}
