package my.rcp.gefeditor.handlers;

import java.io.File;

import my.rcp.gefeditor.editors.MyEditor;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.core.filesystem.EFS;
import org.eclipse.core.filesystem.IFileStore;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.ide.FileStoreEditorInput;

/** This handler opens the editor with temp file input */
public class OpenEditor extends AbstractHandler implements IHandler {

	@Override
	public Object execute(ExecutionEvent event) throws ExecutionException {
		//
		IWorkbenchPage page = PlatformUI.getWorkbench()
			.getActiveWorkbenchWindow().getActivePage();
		try{
			// write a new temp file deleted on JVM exit
			File tempFile = File.createTempFile("tempEditor", "myed");
			tempFile.deleteOnExit();	
			IFileStore fileStore = EFS.getStore( tempFile.toURI() );
			// instantiate input then open MyEditor
			IEditorInput input = new FileStoreEditorInput(fileStore);
			page.openEditor( input, MyEditor.ID );
		} 
		catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}
}
