package my.rcp.gefeditor.mvc.control;

import java.beans.PropertyChangeListener;

import my.rcp.gefeditor.mvc.model.ElementModel;

import org.eclipse.gef.editparts.AbstractGraphicalEditPart;

/** Generic Element superclass implementing the property change listener */
public abstract class ElementEditPart extends AbstractGraphicalEditPart
		implements PropertyChangeListener {

	@Override
	public void activate() {
		if (isActive())
			return;
		super.activate();
		// subscription
		((ElementModel) getModel()).addPropertyChangeListener(this);
	}

	@Override
	public void deactivate() {
		if (!isActive())
			return;
		super.deactivate();
		// de-registration
		((ElementModel) getModel()).removePropertyChangeListener(this);
	}

}
