package my.rcp.gefeditor.mvc.control;

import java.util.List;

import my.rcp.gefeditor.editors.MySchemaXYLayoutEditPolicy;
import my.rcp.gefeditor.mvc.model.MySchema;
import my.rcp.gefeditor.mvc.view.MySchemaFigure;

import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.editparts.AbstractGraphicalEditPart;
/** this implements the Controller for My Schema */
public class MySchemaEditPart extends AbstractGraphicalEditPart {

	/** instantiate controller by passing a model instance */
	public MySchemaEditPart( MySchema model) {
		setModel( model );
	}

	@Override
	protected IFigure createFigure() {
		return new MySchemaFigure();
	}

	@Override
	protected List getModelChildren() {
		return ( (MySchema) getModel() ).getBlocks();
	}
	
	/** this define edit policies for the controller */
	@Override
	protected void createEditPolicies() { 
		installEditPolicy(
				EditPolicy.LAYOUT_ROLE, 
				new MySchemaXYLayoutEditPolicy());
	}

}
