package my.rcp.gefeditor.mvc.model;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

/** Generic model superclass referencing PropertyListener */
public class ElementModel {
	
	transient protected PropertyChangeSupport listeners = 
		new PropertyChangeSupport(this);
	
	public void addPropertyChangeListener(PropertyChangeListener listener){
		listeners.addPropertyChangeListener(listener);
	}
	
	public void removePropertyChangeListener(PropertyChangeListener listener){
		listeners.removePropertyChangeListener(listener);
	}

	protected void firePropertyChange( String prop, Object oldVal, Object newVal ){
		listeners.firePropertyChange(prop, oldVal, newVal);
	} 
	
}
